#pragma once

#include <SDL/SDL.h>
#include <stdbool.h>

struct baton {
  bool up, down, left, right, a, b, start, select;
  bool quit;

  void (*quitCallback)();
};

void conduct(struct baton * b) {
  SDL_Event e;

  while (SDL_PollEvent(&e)) {
    switch(e.type) {
      case SDL_KEYDOWN:
        switch(e.key.keysym.sym) {
          case SDLK_UP:
            b->up = true; break;
          case SDLK_DOWN:
            b->down = true; break;
          case SDLK_LEFT:
            b->left = true; break;
          case SDLK_RIGHT:
            b->right = true; break;
          case SDLK_z:
            b->a = true; break;
          case SDLK_x:
            b->b = true; break;
          case SDLK_RETURN:
            b->start = true; break;
          case SDLK_RSHIFT:
            b->select = true; break;
        }
        break;
      case SDL_KEYUP:
        switch(e.key.keysym.sym) {
          case SDLK_UP:
            b->up = false; break;
          case SDLK_DOWN:
            b->down = false; break;
          case SDLK_LEFT:
            b->left = false; break;
          case SDLK_RIGHT:
            b->right = false; break;
          case SDLK_z:
            b->a = false; break;
          case SDLK_x:
            b->b = false; break;
          case SDLK_RETURN:
            b->start = false; break;
          case SDLK_RSHIFT:
            b->select = false; break;
        }
        break;
      case SDL_QUIT:
        b->quit = true;
        if (b->quitCallback)
          b->quitCallback();
        break;
    }
  }
}

