#include <stdlib.h>
#include <stdio.h>
#include <string.h>

typedef struct {
  char *key;
  void *value;
} PAIR;

typedef struct {
  long size;
  PAIR ** pairs;
} DICT;

DICT dict() {
  DICT dict;
  dict.size = 0;
  dict.pairs = (PAIR **) malloc(0 * sizeof(PAIR *));
  return dict;
}

int dictPut(DICT *dict, char *key, void *value) {
  PAIR *pair = (PAIR *) malloc(sizeof(PAIR));
  dict->size++;
  dict->pairs = (PAIR **) realloc(dict->pairs, dict->size * sizeof(PAIR *));
  pair->key = key;
  pair->value = value;
  dict->pairs[dict->size - 1] = pair;
  return dict->size;
}

void *dictGet(DICT *dict, char *key) {
  for (int i = 0; i < dict->size; i++) {
    if (strcmp(key, dict->pairs[i]->key) == 0) {
      return dict->pairs[i]->value;
    }
  }
  return NULL;
}

void dictEach(DICT *adict, void (*funcptr)(char*, void*) ) {
  int i;
  for(i = 0; i < adict->size; i++) {
    funcptr(adict->pairs[i]->key, adict->pairs[i]->value);
  }
  return;
}

