#pragma once

typedef struct {
  SDL_Surface *canvas;
  SDL_Surface *screen;

  GLuint texture;
} GHOST;

GHOST *display(int hh, int ww, int h, int w) {
  GHOST *display = (GHOST *) malloc(sizeof(GHOST));
  SDL_Init(SDL_INIT_VIDEO);
  atexit(SDL_Quit);
  int flag = SDL_HWSURFACE | SDL_GL_DOUBLEBUFFER | SDL_OPENGL;
  display->screen = SDL_SetVideoMode(h, w, 32, flag);
  display->canvas = SDL_CreateRGBSurface(SDL_HWSURFACE, hh, ww, 32, 0, 0, 0, 0);
  glClearColor(0, 0, 0, 0);
  glClearDepth(1.0f);
  glViewport(0, 0, display->screen->w, display->screen->h);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glOrtho(0, display->screen->w, display->screen->h, 0, 1, -1);
  glMatrixMode(GL_MODELVIEW);
  glEnable(GL_TEXTURE_2D);
  glLoadIdentity();
  glGenTextures(1, &display->texture);
  glBindTexture(GL_TEXTURE_2D, display->texture);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
  return display;
}

void blit(GHOST *dest, SDL_Surface *src, int x, int y) {
  SDL_Rect pos = { .x = x, .y = y };
  SDL_BlitSurface(src, NULL, dest->canvas, &pos);
}

void fill(GHOST *dest, int r, int g, int b) {
  int color = SDL_MapRGB(dest->canvas->format, r, g, b);
  SDL_FillRect(dest->canvas, NULL, color);
}

void sblit(GHOST *s, SHEET *sheet, int frame, int x, int y) {
  SDL_Rect pos = { .x = x, .y = y };
  SDL_BlitSurface(sheet->image, sheet->frames[frame], s->canvas, &pos);
}

void flip(SDL_Surface *surface) {
  SDL_Flip(surface);
}

void draw(GHOST *screen) {
  glBindTexture(GL_TEXTURE_2D, screen->texture);
  glTexImage2D(GL_TEXTURE_2D, 0, 4, screen->canvas->w, screen->canvas->h, 0, GL_BGRA, GL_UNSIGNED_BYTE, screen->canvas->pixels);
  glBindTexture(GL_TEXTURE_2D, screen->texture);
  glBegin(GL_QUADS);
  glTexCoord2i(0, 0);
  glVertex3f(0.f, 0.f, 0.0f );
  glTexCoord2i(1, 0);
  glVertex3f(screen->screen->w, 0.f, 0.f );
  glTexCoord2i(1, 1);
  glVertex3f(screen->screen->w, screen->screen->h, 0.f );
  glTexCoord2i(0, 1);
  glVertex3f(0.f, screen->screen->h, 0.f );
  glEnd();
  SDL_GL_SwapBuffers();
}

