#pragma once

#include <stdlib.h>
#include <string.h>

typedef struct {
  char *key;
  void *value;
} PAIR;

typedef struct {
  long size;
  PAIR ** pairs;
} MAP;

MAP map() {
  MAP map;
  map.size = 0;
  map.pairs = (PAIR **) malloc(0 * sizeof(PAIR *));
  return map;
}

int mapPut(MAP *map, char *key, void *value) {
  PAIR *pair = (PAIR *) malloc(sizeof(PAIR));
  map->size++;
  map->pairs = (PAIR **) realloc(map->pairs, map->size * sizeof(PAIR *));
  pair->key = key;
  pair->value = value;
  map->pairs[map->size - 1] = pair;
  return map->size;
}

void *mapGet(MAP *map, char *key) {
  for (int i = 0; i < map->size; i++) {
    if (strcmp(key, map->pairs[i]->key) == 0) {
      return map->pairs[i]->value;
    }
  }
  return NULL;
}

void mapEach(MAP *amap, void (*funcptr)(char*, void*) ) {
  int i;
  for(i = 0; i < amap->size; i++) {
    funcptr(amap->pairs[i]->key, amap->pairs[i]->value);
  }
  return;
}

