typedef struct {
  SDL_Surface *image;
  int h, w;
  SDL_Rect ** frames;
} SHEET;

SHEET *sheetopen(char *path, int w, int h) {
  SHEET *sheet;
  int cols, rows, total;

  sheet = (SHEET *) malloc(sizeof(SHEET));
  sheet->image = SDL_LoadBMP(path);
  if (sheet->image == NULL)
    exit(1);
  sheet->h = sheet->image->h;
  sheet->w = sheet->image->w;
  cols = sheet->w / w;
  rows = sheet->h / h;
  total = cols * rows;
  printf("%ix%i\n", cols, rows);
  sheet->frames = (SDL_Rect **) malloc(total * sizeof(SDL_Rect *));
  for (int row = 0; row < rows; row++) {
    for (int col = 0; col < cols; col++) {
      SDL_Rect *frame = malloc(sizeof(SDL_Rect));
      frame->x = col * w;
      frame->y = row * h;
      frame->w = w;
      frame->h = h;
      sheet->frames[(row * cols) + col] = frame;
    }
  }
  return sheet;
}
